﻿using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;

namespace NUnit4TeamBuild.NCoverToMSCover
{
    public sealed class CoverageDSPriv
    {
        private readonly IDictionary<string, Module> modules = new Dictionary<string, Module>();
        private readonly IDictionary<string, SourceFile> sourceFiles = new Dictionary<string, SourceFile>();

        public void AddModule(Module module)
        {
            modules[module.ModuleName] = module;
        }

        public XElement ToXElement()
        {
            return new XElement("CoverageDSPriv",
                                modules.Values.OrderBy(m => m.ModuleName).Select(m => m.ToXElement()),
                                sourceFiles.Values.OrderBy(sf => sf.Id).Select(sf => sf.ToXElement()));
        }

        public SourceFile GetSourceFile(string fileName)
        {
            SourceFile sourceFile;
            if (!sourceFiles.TryGetValue(fileName, out sourceFile))
            {
                sourceFile = new SourceFile(fileName);
                sourceFiles.Add(fileName, sourceFile);
            }

            return sourceFile;
        }
    }
}
