﻿using System.Xml.Linq;

namespace NUnit4TeamBuild.NCoverToMSCover
{
    public sealed class SourceFile
    {
        private static int idCounter = 1;
        private readonly int id;
        private readonly string fileName;

        public SourceFile(string fileName)
        {
            this.fileName = fileName;
            id = idCounter;
            idCounter++;
        }

        public int Id
        {
            get
            {
                return id;
            }
        }

        public string FileName
        {
            get
            {
                return fileName;
            }
        }

        public XElement ToXElement()
        {
            return new XElement("SourceFileNames",
                                new XElement("SourceFileID", Id),
                                new XElement("SourceFileName", FileName));
        }
    }
}
