﻿using System;

namespace KWatkins.NUnitTfs
{
    internal class Program
    {
        private static int Main(string[] args)
        {
            // Uncomment to use custom arguments when debugging. (Saves mucking around with start options.
            /*args = new []
                   {
                       "-t", "Project",
                       "-b", "Build",
                       "-n", "PathToNUnitXml",
                       "-v", "2010"
                   };*/

            Options options = Options.ParseOptions(args);

            if (options == null)
            {
                return 1;
            }

            Publisher publisher = PublisherFactory.CreatePublisher(options);
            try
            {
                publisher.Publish();
                return 0;
            }
            catch (Exception exception)
            {
                Console.Error.WriteLine(exception.ToString());
                return 1;
            }
        }
    }
}
