﻿using System;
using KWatkins.NUnitTfs.Tfs2008;
using KWatkins.NUnitTfs.Tfs2010;

namespace KWatkins.NUnitTfs
{
    internal static class PublisherFactory
    {
        internal static Publisher CreatePublisher(Options options)
        {
            switch(options.TfsVersion)
            {
                case 2008:
                    return new Publisher2008(options);

                case 2010:
                    return new Publisher2010(options);
            }

            throw new NotSupportedException(string.Format("TFS version {0} is not supported.", options.TfsVersion));
        }
    }
}
