﻿using System;
using System.Xml.Linq;
using KWatkins.NUnitTfs.Tfs2010.TestResultsServiceV1;

namespace KWatkins.NUnitTfs.Tfs2010
{
    /// <summary>
    /// Maps elements from the .trx to a TestCaseResult instance.
    /// </summary>
    internal sealed class Map
    {
        internal Guid RunId
        {
            get;
            set;
        }
        internal XElement UnitTestElement
        {
            get;
            set;
        }
        internal XElement UnitTestResultElement
        {
            get;
            set;
        }
        internal TestCaseResult TestCaseResult
        {
            get;
            set;
        }

        private byte[] testResultDetailAttachmentBytes;

        internal byte[] TestResultDetailAttachmentBytes
        {
            get
            {
                EnsureTestResultDetailAttachmentBytes();
                return testResultDetailAttachmentBytes;
            }
        }

        private void EnsureTestResultDetailAttachmentBytes()
        {
            if (testResultDetailAttachmentBytes != null)
            {
                return;
            }

            var xml = new XDocument(
                new XElement(Publisher2010.Xmlns + "TestResultDetail",
                             new XAttribute("runId", RunId),
                             new XAttribute("xmlns", Publisher2010.Xmlns.NamespaceName),
                             new XElement(Publisher2010.Xmlns + "TestDefinitions",
                                          new XElement(UnitTestElement)),
                             new XElement(Publisher2010.Xmlns + "Result",
                                          new XElement(UnitTestResultElement))));

            testResultDetailAttachmentBytes = xml.ToBytes();
        }
    }
}
