﻿using System;
using MSTest = Microsoft.VisualStudio.TestTools.UnitTesting;

namespace BaseLine
{
    [NUnit.Framework.TestFixture]
    [MSTest.TestClass]
    public sealed class BaseLineClass
    {
        [NUnit.Framework.Test(Description = "SuccessfulTest description.")]
        [MSTest.TestMethod]
        [MSTest.Description("SuccessfulTest description.")]
        public void SuccessfulTest()
        {
        }

        [NUnit.Framework.Test(Description = "IgnoredTest description.")]
        [NUnit.Framework.Ignore("IgnoredTest reason.")]
        [MSTest.TestMethod]
        [MSTest.Description("IgnoredTest description.")]
        [MSTest.Ignore]
        public void IgnoredTest()
        {
        }

        [NUnit.Framework.Test(Description = "FailedTest description.")]
        [MSTest.TestMethod]
        [MSTest.Description("FailedTest description.")]
        public void FailedTest()
        {
            throw new InvalidOperationException("FailedTest exception message.");
        }

        [NUnit.Framework.Test]
        [MSTest.TestMethod]
        public void SuccessfulTestWithNoDescription()
        {
        }

        [NUnit.Framework.Test]
        public void InconclusiveNUnitTest()
        {
            NUnit.Framework.Assert.Inconclusive("Inconclusive message.");
        }

        [MSTest.TestMethod]
        public void InconclusiveMSTestTest()
        {
            MSTest.Assert.Inconclusive("Inconclusive message.");
        }
    }
}
